/*
 * CHEST, chess analyst.  For Copyright notice read file "COPYRIGHT".
 *
 * $Source: /user/drb/heiner/ca/chest/RCS/acmsize.h,v $
 * $Id: acmsize.h,v 3.4 1997/09/09 19:02:12 heiner Exp $
 *
 *	sizing of adaptive chess memory
 */

/*
 * Our cache memory is allocated statically, i.e. dedicated.
 * We decide for a certain number of megabytes to be used,
 * and derive a prime number of slots from this.
 * Each entry is considered to occupy 40 bytes, i.e. 25000 nodes per Mbyte.
 */
#ifndef ACM_MEGS
# define ACM_MEGS	42		/* CF: standard value is 5 */
#endif

#ifndef ACM_SLOTS

#if ACM_MEGS <= 	0
# define ACM_SLOTS	12497
#endif
#if ACM_MEGS == 	1
# define ACM_SLOTS	24989
#endif
#if ACM_MEGS == 	2
# define ACM_SLOTS	49999
#endif
#if ACM_MEGS == 	3
# define ACM_SLOTS	74959
#endif
#if ACM_MEGS == 	4
# define ACM_SLOTS	99991
#endif
#if ACM_MEGS == 	5
# define ACM_SLOTS	124991
#endif
#if ACM_MEGS == 	6
# define ACM_SLOTS	149993
#endif
#if ACM_MEGS == 	7
# define ACM_SLOTS	174991
#endif
#if ACM_MEGS == 	8
# define ACM_SLOTS	199999
#endif
#if ACM_MEGS == 	9
# define ACM_SLOTS	224993
#endif
#if ACM_MEGS == 	10
# define ACM_SLOTS	249989
#endif
#if ACM_MEGS == 	11
# define ACM_SLOTS	274993
#endif
#if ACM_MEGS == 	12
# define ACM_SLOTS	299993
#endif
#if ACM_MEGS == 	13
# define ACM_SLOTS	324997
#endif
#if ACM_MEGS == 	14
# define ACM_SLOTS	349981
#endif
#if ACM_MEGS == 	15
# define ACM_SLOTS	374993
#endif
#if ACM_MEGS == 	16
# define ACM_SLOTS	399989
#endif
#if ACM_MEGS == 	17
# define ACM_SLOTS	424997
#endif
#if ACM_MEGS == 	18
# define ACM_SLOTS	449989
#endif
#if ACM_MEGS == 	19
# define ACM_SLOTS	474983
#endif
#if ACM_MEGS == 	20
# define ACM_SLOTS	499979
#endif
#if ACM_MEGS == 	21
# define ACM_SLOTS	524999
#endif
#if ACM_MEGS == 	22
# define ACM_SLOTS	549979
#endif
#if ACM_MEGS == 	23
# define ACM_SLOTS	574969
#endif
#if ACM_MEGS == 	24
# define ACM_SLOTS	599999
#endif
#if ACM_MEGS == 	25
# define ACM_SLOTS	624997
#endif
#if ACM_MEGS == 	26
# define ACM_SLOTS	649991
#endif
#if ACM_MEGS == 	27
# define ACM_SLOTS	674987
#endif
#if ACM_MEGS == 	28
# define ACM_SLOTS	699967
#endif
#if ACM_MEGS == 	29
# define ACM_SLOTS	724993
#endif
#if ACM_MEGS == 	30
# define ACM_SLOTS	749993
#endif
#if ACM_MEGS == 	31
# define ACM_SLOTS	774997
#endif
#if ACM_MEGS == 	32
# define ACM_SLOTS	799999
#endif
#if ACM_MEGS == 	33
# define ACM_SLOTS	824983
#endif
#if ACM_MEGS == 	34
# define ACM_SLOTS	849997
#endif
#if ACM_MEGS == 	35
# define ACM_SLOTS	874987
#endif
#if ACM_MEGS == 	36
# define ACM_SLOTS	899981
#endif
#if ACM_MEGS == 	37
# define ACM_SLOTS	924997
#endif
#if ACM_MEGS == 	38
# define ACM_SLOTS	949997
#endif
#if ACM_MEGS == 	39
# define ACM_SLOTS	974999
#endif
#if ACM_MEGS == 	40
# define ACM_SLOTS	999983
#endif
#if ACM_MEGS == 	41
# define ACM_SLOTS	1024997
#endif
#if ACM_MEGS == 	42
# define ACM_SLOTS	1049999
#endif
#if ACM_MEGS == 	43
# define ACM_SLOTS	1074991
#endif
#if ACM_MEGS == 	44
# define ACM_SLOTS	1099997
#endif
#if ACM_MEGS == 	45
# define ACM_SLOTS	1124993
#endif
#if ACM_MEGS == 	46
# define ACM_SLOTS	1149991
#endif
#if ACM_MEGS == 	47
# define ACM_SLOTS	1174973
#endif
#if ACM_MEGS == 	48
# define ACM_SLOTS	1199999
#endif
#if ACM_MEGS == 	49
# define ACM_SLOTS	1224991
#endif
#if ACM_MEGS == 	50
# define ACM_SLOTS	1249999
#endif
#if ACM_MEGS == 	51
# define ACM_SLOTS	1274989
#endif
#if ACM_MEGS == 	52
# define ACM_SLOTS	1299989
#endif
#if ACM_MEGS == 	53
# define ACM_SLOTS	1324979
#endif
#if ACM_MEGS == 	54
# define ACM_SLOTS	1349993
#endif
#if ACM_MEGS == 	55
# define ACM_SLOTS	1374983
#endif
#if ACM_MEGS == 	56
# define ACM_SLOTS	1399999
#endif
#if ACM_MEGS == 	57
# define ACM_SLOTS	1424989
#endif
#if ACM_MEGS == 	58
# define ACM_SLOTS	1449983
#endif
#if ACM_MEGS == 	59
# define ACM_SLOTS	1474999
#endif
#if ACM_MEGS == 	60
# define ACM_SLOTS	1499977
#endif
#if ACM_MEGS >  	60
# define ACM_SLOTS	(((ACM_MEGS * 12497) * 2) + 1)
#endif

#endif	/* ndef ACM_SLOTS */
