/*
 * CHEST, chess analyst.  For Copyright notice read file "COPYRIGHT".
 *
 * $Source: /home/heiner/ca/chest/RCS/move.h,v $
 * $Id: move.h,v 3.7 1999/07/20 21:05:27 heiner Exp $
 *
 *	execute moves and undo them
 */

#ifndef CHEST_move_h_INCLUDED
#define CHEST_move_h_INCLUDED

#include "types.h"
#include "board.h"
#include "stats.h"

Extern Counter	sc_move_exec;	/* #(executed moves) */

Extern void	move_stats   (Bool print);
#if USE_XATT
# include "xatt.h"
# define ins_att(bp, fp)     xatt_ins(bp, fp)
#else
  Extern void	add_att      (Board*, Field*);
# define ins_att(bp, fp)     add_att(bp, fp)
#endif
Extern void	pacb_sync    (PackedBoard*, const Field*);
Extern void	move_undo    (Board*);
Extern void	move_execute (Board*, const Move*);
Extern Zhash	move_snoop   (const Board*, const Move*,
				uint32		pkarr[8],
				Position*	epp,
				Castle		castle[2]);

#endif	/* ndef CHEST_move_h_INCLUDED */
